# sahi
# stroyka.in
# Дата: 15.06.2012
# selection_edge.rb
# Дата обновления: 15.02.2016
# :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< 
module Sahi
                   
module MySelection

require "sketchup.rb"

class MySelectionEdge<Sketchup::SelectionObserver

   def initialize()
      @select_edge = false
      @select_face = false
      @edge_smooth = false
      @nomer = Sketchup.version_number
    end
       
   def onSelectionBulkChange(selection)
	   get_selection_edge(selection) if(@select_edge)
     get_selection_edge_smooth(selection) if(@edge_smooth)
     get_selection_face(selection) if(@select_face)
   end
   
   def start_selection_edge
     if(@select_edge) then 
       @select_edge = false
     	Sketchup.active_model.selection.remove_observer self if(@nomer > 5000260)
     else
       @select_edge = true
       @select_face = false
       @edge_smooth = false
       get_selection_edge(Sketchup.active_model.selection)
       MySelectionEdge.new
       Sketchup.active_model.selection.add_observer self if(@nomer > 5000260)
     end
   end 
   
 def start_selection_edge_smooth
     if(@edge_smooth) then 
      @edge_smooth = false
     	 Sketchup.active_model.selection.remove_observer self if(@nomer > 5000260)
     else
       @edge_smooth = true
       @select_edge = false
       @select_face = false
       get_selection_edge_smooth(Sketchup.active_model.selection)
       Sketchup.active_model.selection.add_observer self if(@nomer > 5000260)
     end
  end 
   
  def start_selection_face
     if(@select_face) then 
      @select_face = false
     	Sketchup.active_model.selection.remove_observer self if(@nomer > 5000260)
     else
      @select_face = true
      @select_edge = false
      @edge_smooth = false
      get_selection_face(Sketchup.active_model.selection)
      Sketchup.active_model.selection.add_observer self if(@nomer > 5000260)
     end
   end 
   
  def get_selection_edge(sel)
      sel.to_a.each{|item| sel.remove(item) unless item.class == Sketchup::Edge }
      end
       
   def get_selection_edge_smooth(sel)
         sel.to_a.each{|item| 
         sel.remove(item) if item.class == Sketchup::Face 
         if item.class == Sketchup::Edge
           sel.remove(item) unless item.hidden? or item.soft?
           end
           }
      end
       
  def get_selection_face(sel)
         sel.to_a.each{|item| sel.remove(item) unless item.class == Sketchup::Face}
       end
  
  def edge_selection
		if(@select_edge) then
      
			return MF_CHECKED
		else
			return MF_UNCHECKED			
		end
	end
  
   def edge_smooth
		if(@edge_smooth) then
			return MF_CHECKED
		else
		return MF_UNCHECKED			
		end
	end
  
  def face_selection
		if(@select_face) then
			return MF_CHECKED
		else
		return MF_UNCHECKED			
		end
	end
  
end
#----------------------------------------------
if( not file_loaded?(File.basename(__FILE__)))
   select_edge = Sahi::MySelection::MySelectionEdge.new

   sahi_toolbar_tools = UI::Toolbar.new("Select >>")
   cmd = UI::Command.new("Select Edges"){ select_edge.start_selection_edge }
   cmd.tooltip = "Select Edges" 
   cmd.status_bar_text = "Select Edges"
   cmd.large_icon = "./images/edge.png"
   cmd.small_icon = "./images/edge.png"
   cmd.set_validation_proc{select_edge.edge_selection}
   
   cmd1 = UI::Command.new("Select Face"){ select_edge.start_selection_face }
   cmd1.tooltip = "Select Face"
   cmd1.status_bar_text = "Select Face"
   cmd1.large_icon = "./images/face.png"
   cmd1.small_icon = "./images/face.png"
   cmd1.set_validation_proc {select_edge.face_selection}
   
   cmd2 = UI::Command.new("Select hidden lines"){ select_edge.start_selection_edge_smooth }
   cmd2.tooltip = "Select the hidden lines" 
   cmd2.status_bar_text = "Select the hidden lines"
   cmd2.large_icon = "./images/edge.png"
   cmd2.small_icon = "./images/edge.png"
   cmd2.set_validation_proc {select_edge.edge_smooth}
 
   sahi_toolbar_tools.add_item(cmd)
   sahi_toolbar_tools.add_item(cmd1)
   sahi_toolbar_tools.add_item(cmd2)
   sahi_toolbar_tools.show

end
#=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=#
end #MySelection
          
end # Sahi
